---
title: MediaStreamTrack.getConstraints()
slug: Web/API/MediaStreamTrack/getConstraints
tags:
  - API
  - Media Capture and Streams
  - Media Streams API
  - MediaStreamTrack
  - Method
  - Reference
  - getConstraints
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p><span class="seoSummary">The <strong><code>getConstraints()</code></strong> method of the {{domxref("MediaStreamTrack")}} interface returns a {{domxref('MediaTrackConstraints')}} object containing the set of constraints most recently established for the track using a prior call to {{domxref("MediaStreamTrack.applyConstraints", "applyConstraints()")}}. These constraints indicate values and ranges of values that the Web site or application has specified are required or acceptable for the included constrainable properties.</span></p>

<p>Constraints can be used to ensure that the media meets certain guidelines you prefer. For example, you may prefer high definition video but require that the frame rate be a little low to help keep the data rate low enough not overtax the network. Constraints can also specify ideal and/or acceptable sizes or ranges of sizes. See <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a> for details on how to work with constrainable properties.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">const <em>constraints</em> = <em>track</em>.getConstraints()</pre>

<h3 id="Return_value"><span style="font-size: 1.714rem; letter-spacing: -0.021em; line-height: 1;">Return value</span></h3>

<p>A {{domxref('MediaTrackConstraints')}} object which indicates the constrainable properties the Web site or app most recently set using {{domxref("MediaStreamTrack.applyConstraints", "applyConstraints()")}}. The properties in the returned object are listed in the same order as when they were set, and only properties specifically set by the site or app are included.</p>

<div class="note">
<p><strong>Note:</strong> The returned set of constraints doesn't necessarily describe the actual state of the media. Even if any of the constraints couldn't be met, they are still included in the returned object as originally set by the site's code. To get the currently active settings for all constrainable properties, you should instead call {{domxref("MediaStreamTrack.getSettings", "getSettings()")}}.</p>
</div>

<h2 id="Example">Example</h2>

<p>This example obtains the current constraints for a track, sets the {{domxref("MediaTrackConstraints.facingMode", "facingMode")}}, and applies the updated constraints.</p>

<pre class="brush: js">function switchCameras(track, camera) {
  const constraints = track.getConstraints();
  constraints.facingMode = camera;
  track.applyConstraints(constraints);
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Media Capture', '#dom-mediastreamtrack-getconstraints', 'getConstraints()')}}</td>
   <td>{{Spec2('Media Capture')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaStreamTrack.getConstraints")}}</p>
